

<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" />
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  
  <title>posydon.grids.downsampling &mdash; posydon 0+untagged.3754.gf69f455.dirty documentation</title>
  

  
  <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />

  
  

  
  

  

  
  <!--[if lt IE 9]>
    <script src="../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../../../" src="../../../_static/documentation_options.js"></script>
        <script src="../../../_static/jquery.js"></script>
        <script src="../../../_static/underscore.js"></script>
        <script src="../../../_static/doctools.js"></script>
        <script src="../../../_static/language_data.js"></script>
    
    <script type="text/javascript" src="../../../_static/js/theme.js"></script>

    
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../../../index.html" class="icon icon-home"> posydon
          

          
          </a>

          
            
            
              <div class="version">
                0+untagged.3754.gf69f455.dirty
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        
        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../../../install/index.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../run_mesa_grids/inifile.html">Configuration files for POSYDON</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../run_mesa_grids/dynamic/dynamic.html">Run a Dynamic MESA Grid</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../run_mesa_grids/fixed/fixed.html">Run a Fixed MESA Grid</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../PSyGrid/PSyGrid.html">The PSyGrid Object</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../PSyGrid/plot2D/plot2D.html">Showcase of 2D plotting functionalities</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../PSyGrid/plot1D/plot1D.html">Showcase of 1D plotting functionalities</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../SingleStar/SingleStar.html">The Single Star Object</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../BinaryStar/BinaryStar.html">The Binary Star Object</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../visualization/VH_diagram.html">Van den Heuvel diagrams</a></li>
</ul>

            
          
        </div>
        
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">posydon</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          

















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../../index.html" class="icon icon-home"></a> &raquo;</li>
        
          <li><a href="../../index.html">Module code</a> &raquo;</li>
        
      <li>posydon.grids.downsampling</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <h1>Source code for posydon.grids.downsampling</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot;Module for downsampling accross a path in multi-dimensional space.</span>

<span class="sd">Let a d-dimensional parametric curve in of the form:</span>

<span class="sd">    x_1 = x_1(t)</span>
<span class="sd">    x_2 = x_2(t)</span>
<span class="sd">    ...</span>
<span class="sd">    x_d = x_d(t)</span>

<span class="sd">sampled at N time steps, t_1, t_2, ..., t_N. It is possible to select a subset</span>
<span class="sd">of the time steps - essentially defining a downsampled version of the curve -</span>
<span class="sd">so that the original curve can be reconstructed with minimum error.</span>

<span class="sd">The provided class `TrackDownsampler` performs the downsampling. It requires</span>
<span class="sd">two input arrays. The first is the &quot;independent&quot; variable, t, which does not</span>
<span class="sd">have to be temporal (e.g., spatial), but must be strictly increasing. The 2nd</span>
<span class="sd">array is the track, in which the different columns correspond to the different</span>
<span class="sd">dimensions:</span>

<span class="sd">    --- parameters ---&gt;</span>

<span class="sd">  |     x_1(t_1)    x_2(t_1)    ...     x_d(t_1)</span>
<span class="sd">time    x_1(t_2)    x_2(t_2)    ...     x_d(t_2)</span>
<span class="sd"> or         .           .       ...         .</span>
<span class="sd"> any        .           .       ...         .</span>
<span class="sd">  |         .           .       ...         .</span>
<span class="sd">  V     x_1(t_N)    x_2(t_N)    ...     x_d(t_N)</span>


<span class="sd"> Usage example</span>
<span class="sd"> -------------</span>
<span class="sd"> TD = TrackDownsample(t, X)</span>
<span class="sd"> t_new, X_new = TD.downsample(max_err=0.001)</span>


<span class="sd">&quot;&quot;&quot;</span>


<span class="n">__author__</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;Konstantinos Kovlakas &lt;kkovlakas@physics.uoc.gr&gt;&#39;</span><span class="p">]</span>


<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>
<span class="kn">import</span> <span class="nn">warnings</span>
<span class="kn">import</span> <span class="nn">sys</span>


<span class="n">sys</span><span class="o">.</span><span class="n">setrecursionlimit</span><span class="p">(</span><span class="mi">100000</span><span class="p">)</span>


<div class="viewcode-block" id="rescale_from_0_to_1"><a class="viewcode-back" href="../../../api/posydon.grids.downsampling.html#posydon.grids.downsampling.rescale_from_0_to_1">[docs]</a><span class="k">def</span> <span class="nf">rescale_from_0_to_1</span><span class="p">(</span><span class="n">array</span><span class="p">,</span> <span class="n">return_minmax</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;Rescale a matrix so that all dimensions span from 0 to 1.&quot;&quot;&quot;</span>
    <span class="n">arr</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">array</span><span class="p">)</span>
    <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">array</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span> <span class="o">!=</span> <span class="mi">2</span><span class="p">:</span>
        <span class="k">raise</span> <span class="ne">ValueError</span><span class="p">(</span><span class="s2">&quot;Scaler works for matrices only.&quot;</span><span class="p">)</span>

    <span class="n">minima</span><span class="p">,</span> <span class="n">maxima</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">min</span><span class="p">(</span><span class="n">arr</span><span class="p">,</span> <span class="n">axis</span><span class="o">=</span><span class="mi">0</span><span class="p">),</span> <span class="n">np</span><span class="o">.</span><span class="n">max</span><span class="p">(</span><span class="n">arr</span><span class="p">,</span> <span class="n">axis</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>

    <span class="k">for</span> <span class="n">col</span><span class="p">,</span> <span class="n">minimum</span><span class="p">,</span> <span class="n">maximum</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="nb">range</span><span class="p">(</span><span class="n">arr</span><span class="o">.</span><span class="n">shape</span><span class="p">[</span><span class="mi">1</span><span class="p">]),</span> <span class="n">minima</span><span class="p">,</span> <span class="n">maxima</span><span class="p">):</span>
        <span class="k">if</span> <span class="n">minimum</span> <span class="o">==</span> <span class="n">maximum</span><span class="p">:</span>
            <span class="n">arr</span><span class="p">[:,</span> <span class="n">col</span><span class="p">]</span> <span class="o">=</span> <span class="mf">0.0</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">arr</span><span class="p">[:,</span> <span class="n">col</span><span class="p">]</span> <span class="o">=</span> <span class="p">(</span><span class="n">arr</span><span class="p">[:,</span> <span class="n">col</span><span class="p">]</span> <span class="o">-</span> <span class="n">minimum</span><span class="p">)</span> <span class="o">/</span> <span class="p">(</span><span class="n">maximum</span> <span class="o">-</span> <span class="n">minimum</span><span class="p">)</span>

    <span class="k">if</span> <span class="n">return_minmax</span><span class="p">:</span>
        <span class="k">return</span> <span class="n">arr</span><span class="p">,</span> <span class="n">minima</span><span class="p">,</span> <span class="n">maxima</span>
    <span class="k">return</span> <span class="n">arr</span></div>


<div class="viewcode-block" id="TrackDownsampler"><a class="viewcode-back" href="../../../api/posydon.grids.downsampling.html#posydon.grids.downsampling.TrackDownsampler">[docs]</a><span class="k">class</span> <span class="nc">TrackDownsampler</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;Class performing downsampling of multi-dimensional paths.&quot;&quot;&quot;</span>

    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">independent</span><span class="p">,</span> <span class="n">dependent</span><span class="p">,</span> <span class="n">verbose</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Get, reduce and rescale data.&quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">verbose</span> <span class="o">=</span> <span class="n">verbose</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">say</span><span class="p">(</span><span class="s2">&quot;Initializing downsampler.&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">keep</span> <span class="o">=</span> <span class="kc">None</span>    <span class="c1"># boolean array inidicating rows to keep</span>

        <span class="k">if</span> <span class="ow">not</span> <span class="n">np</span><span class="o">.</span><span class="n">iterable</span><span class="p">(</span><span class="n">independent</span><span class="p">):</span>
            <span class="k">raise</span> <span class="ne">ValueError</span><span class="p">(</span><span class="s2">&quot;`independent` is not iterable.&quot;</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">np</span><span class="o">.</span><span class="n">iterable</span><span class="p">(</span><span class="n">independent</span><span class="p">[</span><span class="mi">0</span><span class="p">]):</span>
            <span class="k">raise</span> <span class="ne">ValueError</span><span class="p">(</span><span class="s2">&quot;`independent` should be one-dimensional.&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">t</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">independent</span><span class="p">)</span>

        <span class="k">if</span> <span class="ow">not</span> <span class="n">np</span><span class="o">.</span><span class="n">iterable</span><span class="p">(</span><span class="n">dependent</span><span class="p">):</span>
            <span class="k">raise</span> <span class="ne">ValueError</span><span class="p">(</span><span class="s2">&quot;`dependent` is not iterable.&quot;</span><span class="p">)</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">X</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">dependent</span><span class="p">)</span>

        <span class="k">if</span> <span class="ow">not</span> <span class="n">np</span><span class="o">.</span><span class="n">iterable</span><span class="p">(</span><span class="n">dependent</span><span class="p">[</span><span class="mi">0</span><span class="p">]):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">X</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">X</span><span class="o">.</span><span class="n">reshape</span><span class="p">((</span><span class="o">-</span><span class="mi">1</span><span class="p">,</span> <span class="mi">1</span><span class="p">))</span>

        <span class="k">if</span> <span class="n">np</span><span class="o">.</span><span class="n">iterable</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">X</span><span class="p">[</span><span class="mi">0</span><span class="p">,</span> <span class="mi">0</span><span class="p">]):</span>
            <span class="k">raise</span> <span class="ne">ValueError</span><span class="p">(</span><span class="s2">&quot;Number of dimensions in `dependent` &gt; 2.&quot;</span><span class="p">)</span>

        <span class="c1"># ensure `independent` is strictly increasing</span>
        <span class="k">if</span> <span class="n">np</span><span class="o">.</span><span class="n">any</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">diff</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">t</span><span class="p">)</span> <span class="o">&lt;=</span> <span class="mi">0</span><span class="p">):</span>
            <span class="k">raise</span> <span class="ne">ValueError</span><span class="p">(</span><span class="s2">&quot;`independent` should be strictly increasing.&quot;</span><span class="p">)</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">rescale</span><span class="p">()</span>

<div class="viewcode-block" id="TrackDownsampler.say"><a class="viewcode-back" href="../../../api/posydon.grids.downsampling.html#posydon.grids.downsampling.TrackDownsampler.say">[docs]</a>    <span class="k">def</span> <span class="nf">say</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">message</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Speak to the standard output, only if `.verbose` is False.&quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">verbose</span><span class="p">:</span>
            <span class="nb">print</span><span class="p">(</span><span class="n">message</span><span class="p">)</span></div>

<div class="viewcode-block" id="TrackDownsampler.rescale"><a class="viewcode-back" href="../../../api/posydon.grids.downsampling.html#posydon.grids.downsampling.TrackDownsampler.rescale">[docs]</a>    <span class="k">def</span> <span class="nf">rescale</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Rescale the parameter space from 0 to 1.&quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">say</span><span class="p">(</span><span class="s2">&quot;Rescaling data.&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">X</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">minima</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">maxima</span> <span class="o">=</span> <span class="n">rescale_from_0_to_1</span><span class="p">(</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">X</span><span class="p">,</span> <span class="n">return_minmax</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">say</span><span class="p">(</span><span class="s2">&quot;    done.&quot;</span><span class="p">)</span></div>

<div class="viewcode-block" id="TrackDownsampler.extract_downsample"><a class="viewcode-back" href="../../../api/posydon.grids.downsampling.html#posydon.grids.downsampling.TrackDownsampler.extract_downsample">[docs]</a>    <span class="k">def</span> <span class="nf">extract_downsample</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">scale_back</span><span class="o">=</span><span class="kc">True</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Extract the downsampled array.&quot;&quot;&quot;</span>
        <span class="n">t</span><span class="p">,</span> <span class="n">X</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">t</span><span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">keep</span><span class="p">],</span> <span class="bp">self</span><span class="o">.</span><span class="n">X</span><span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">keep</span><span class="p">,</span> <span class="p">:]</span>
        <span class="k">if</span> <span class="n">scale_back</span><span class="p">:</span>
            <span class="n">t</span><span class="p">,</span> <span class="n">X</span> <span class="o">=</span> <span class="n">t</span><span class="p">,</span> <span class="p">(</span><span class="n">X</span> <span class="o">*</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">maxima</span> <span class="o">-</span> <span class="bp">self</span><span class="o">.</span><span class="n">minima</span><span class="p">))</span> <span class="o">+</span> <span class="bp">self</span><span class="o">.</span><span class="n">minima</span>
        <span class="k">return</span> <span class="n">t</span><span class="p">,</span> <span class="n">X</span></div>

<div class="viewcode-block" id="TrackDownsampler.find_downsample"><a class="viewcode-back" href="../../../api/posydon.grids.downsampling.html#posydon.grids.downsampling.TrackDownsampler.find_downsample">[docs]</a>    <span class="k">def</span> <span class="nf">find_downsample</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">max_err</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Find the rows of the data that constitute the &quot;down-sample&quot;.&quot;&quot;&quot;</span>
        <span class="n">t</span><span class="p">,</span> <span class="n">X</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">t</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">X</span>
        <span class="n">N</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">t</span><span class="p">)</span>

        <span class="k">if</span> <span class="n">max_err</span> <span class="ow">is</span> <span class="kc">None</span> <span class="ow">or</span> <span class="n">N</span> <span class="o">&lt;</span> <span class="mi">3</span><span class="p">:</span>
            <span class="k">return</span> <span class="n">np</span><span class="o">.</span><span class="n">ones_like</span><span class="p">(</span><span class="n">t</span><span class="p">,</span> <span class="n">dtype</span><span class="o">=</span><span class="nb">bool</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">max_err</span> <span class="o">&lt;</span> <span class="mf">0.0</span> <span class="ow">or</span> <span class="ow">not</span> <span class="n">np</span><span class="o">.</span><span class="n">isfinite</span><span class="p">(</span><span class="n">max_err</span><span class="p">):</span>
            <span class="k">raise</span> <span class="ne">ValueError</span><span class="p">(</span><span class="s2">&quot;`max_err` must be a non-negative finite number.&quot;</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">max_err</span> <span class="o">&gt;=</span> <span class="mf">1.0</span><span class="p">:</span>
            <span class="n">warnings</span><span class="o">.</span><span class="n">warn</span><span class="p">(</span><span class="s2">&quot;`max_err` &gt;= 1.0 is like disabling downsampling.&quot;</span><span class="p">)</span>

        <span class="n">keep</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">zeros_like</span><span class="p">(</span><span class="n">t</span><span class="p">,</span> <span class="n">dtype</span><span class="o">=</span><span class="nb">bool</span><span class="p">)</span>  <span class="c1"># initially keep no row</span>

        <span class="k">def</span> <span class="nf">DS</span><span class="p">(</span><span class="n">i</span><span class="p">,</span> <span class="n">j</span><span class="p">,</span> <span class="n">tolerance</span><span class="p">):</span>
            <span class="k">if</span> <span class="n">j</span> <span class="o">&lt;=</span> <span class="n">i</span> <span class="o">+</span> <span class="mi">1</span><span class="p">:</span>
                <span class="k">return</span>
            <span class="n">X_i</span><span class="p">,</span> <span class="n">X_j</span> <span class="o">=</span> <span class="n">X</span><span class="p">[</span><span class="n">i</span><span class="p">,</span> <span class="p">:],</span> <span class="n">X</span><span class="p">[</span><span class="n">j</span><span class="p">,</span> <span class="p">:]</span>    <span class="c1"># points at the ends</span>
            <span class="n">t_i</span><span class="p">,</span> <span class="n">dt</span> <span class="o">=</span> <span class="n">t</span><span class="p">[</span><span class="n">i</span><span class="p">],</span> <span class="n">t</span><span class="p">[</span><span class="n">j</span><span class="p">]</span> <span class="o">-</span> <span class="n">t</span><span class="p">[</span><span class="n">i</span><span class="p">]</span>    <span class="c1"># t-coordinate at the start and dt</span>
            <span class="n">t_intermediate</span> <span class="o">=</span> <span class="n">t</span><span class="p">[</span><span class="n">i</span><span class="o">+</span><span class="mi">1</span><span class="p">:</span><span class="n">j</span><span class="p">]</span>      <span class="c1"># t values for intermediate points</span>
            <span class="n">X_intermediate</span> <span class="o">=</span> <span class="n">X</span><span class="p">[</span><span class="n">i</span><span class="o">+</span><span class="mi">1</span><span class="p">:</span><span class="n">j</span><span class="p">]</span>      <span class="c1"># intermediate points</span>

            <span class="c1"># interpolate all coordinates simulataneously</span>
            <span class="n">X_intepolated</span> <span class="o">=</span> <span class="n">X_i</span> <span class="o">+</span> <span class="n">np</span><span class="o">.</span><span class="n">outer</span><span class="p">(</span><span class="n">t_intermediate</span><span class="o">-</span><span class="n">t_i</span><span class="p">,</span> <span class="n">X_j</span><span class="o">-</span><span class="n">X_i</span><span class="p">)</span> <span class="o">/</span> <span class="n">dt</span>
            <span class="k">del</span> <span class="n">X_j</span><span class="p">,</span> <span class="n">X_i</span><span class="p">,</span> <span class="n">t_intermediate</span><span class="p">,</span> <span class="n">t_i</span><span class="p">,</span> <span class="n">dt</span>

            <span class="c1"># compute the error (as in 2-norm) for all intermediate points</span>
            <span class="n">X_err</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">linalg</span><span class="o">.</span><span class="n">norm</span><span class="p">(</span><span class="n">X_intermediate</span> <span class="o">-</span> <span class="n">X_intepolated</span><span class="p">,</span> <span class="n">axis</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>
            <span class="k">del</span> <span class="n">X_intermediate</span><span class="p">,</span> <span class="n">X_intepolated</span>
            <span class="c1"># and find the maximum error and the corresponding index</span>
            <span class="n">argmax</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">argmax</span><span class="p">(</span><span class="n">X_err</span><span class="p">)</span>
            <span class="n">e_max</span> <span class="o">=</span> <span class="n">X_err</span><span class="p">[</span><span class="n">argmax</span><span class="p">]</span>
            <span class="n">k</span> <span class="o">=</span> <span class="n">i</span> <span class="o">+</span> <span class="mi">1</span> <span class="o">+</span> <span class="n">argmax</span>
            <span class="k">del</span> <span class="n">X_err</span><span class="p">,</span> <span class="n">argmax</span>

            <span class="c1"># if below tolerance search no more,</span>
            <span class="c1"># otherwise mark the point and continue at its left and right</span>
            <span class="k">if</span> <span class="n">e_max</span> <span class="o">&gt;</span> <span class="n">tolerance</span><span class="p">:</span>
                <span class="n">keep</span><span class="p">[</span><span class="n">k</span><span class="p">]</span> <span class="o">=</span> <span class="kc">True</span>
                <span class="n">DS</span><span class="p">(</span><span class="n">i</span><span class="p">,</span> <span class="n">k</span><span class="p">,</span> <span class="n">tolerance</span><span class="p">)</span>
                <span class="n">DS</span><span class="p">(</span><span class="n">k</span><span class="p">,</span> <span class="n">j</span><span class="p">,</span> <span class="n">tolerance</span><span class="p">)</span>

        <span class="c1"># keep the first and last point</span>
        <span class="n">keep</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="n">keep</span><span class="p">[</span><span class="n">N</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> <span class="o">=</span> <span class="kc">True</span><span class="p">,</span> <span class="kc">True</span>
        <span class="c1"># ...and the intermediate ones that can&#39;t be accurately interpolated</span>
        <span class="n">DS</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">N</span><span class="o">-</span><span class="mi">1</span><span class="p">,</span> <span class="n">tolerance</span><span class="o">=</span><span class="n">max_err</span><span class="p">)</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">keep</span> <span class="o">=</span> <span class="n">keep</span></div>

<div class="viewcode-block" id="TrackDownsampler.downsample"><a class="viewcode-back" href="../../../api/posydon.grids.downsampling.html#posydon.grids.downsampling.TrackDownsampler.downsample">[docs]</a>    <span class="k">def</span> <span class="nf">downsample</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">max_err</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">scale_back</span><span class="o">=</span><span class="kc">True</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Perform the downsampling and return the result.&quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">find_downsample</span><span class="p">(</span><span class="n">max_err</span><span class="o">=</span><span class="n">max_err</span><span class="p">)</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">extract_downsample</span><span class="p">(</span><span class="n">scale_back</span><span class="o">=</span><span class="n">scale_back</span><span class="p">)</span></div></div>
</pre></div>

           </div>
           
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>
        &#169; Copyright 2019, Tassos Fragkos.

    </p>
  </div>
    
    
    
    Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    
    provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>
        </div>
      </div>

    </section>

  </div>
  

  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>